<template>
  <q-layout view="hHh LpR fFf">
    <q-header class="bg-secondary">
      <q-toolbar class="q-pl-none">
        <div class="logo flex flex-center">
          <q-avatar
            class="cursor-pointer"
            @click="$router.push('/')"
          >
            <img
              src="favicon.ico"
              height="36"
              width="36"
            >
          </q-avatar>
        </div>

        <q-separator
          vertical
          dark
        />

        <q-list
          v-if="avaliableWriting"
          class="q-px-md"
        >
          <q-item>
            <q-item-section>
              <q-item-label>
                <div
                  class="text-body1"
                  v-text="`Envios disponíveis: ${avaliableWriting.quantityAvaliable}`"
                />
              </q-item-label>

              <q-item-label caption>
                <span
                  class="text-grey-5"
                  v-text="'Validade: '"
                />

                <span
                  class="text-amber-3"
                  v-text="avaliableWriting.dateLimit"
                />
              </q-item-label>
            </q-item-section>
          </q-item>
        </q-list>

        <q-separator
          vertical
          dark
        />

        <q-space />

        <menu-profile />
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="drawer"
      content-class="bg-secondary"
      :mini-width="70"
      :mini="mini"
      show-if-above
      mini-to-overlay
      @mouseout="mini = true"
      @mouseover="mini = false"
    >
      <q-scroll-area class="fit">
        <q-separator dark />

        <q-list
          separator
          dark
        >
          <menu-item
            v-for="(item, index) in items"
            :key="index"
            :item="item"
            style="padding: 20px"
          />
        </q-list>

        <q-separator dark />
      </q-scroll-area>
    </q-drawer>

    <q-drawer
      v-if="isComposing"
      v-model="drawer"
      content-class="bg-secondary"
      show-if-above
      :width="320"
      side="right"
    >
      <q-separator dark />

      <div
        v-if="!submit"
        class="text-center q-px-lg q-pt-lg"
      >
        <q-btn
          class="super-rounded-borders full-width"
          label="Enviar Redação"
          color="primary"
          padding="14px"
          unelevated
          @click="submit = true"
        />
      </div>

      <card-topic :topic="topic" />

      <div class="text-center q-px-lg">
        <q-btn
          v-if="hasRating"
          class="super-rounded-borders full-width"
          text-color="accent"
          label="Avaliação"
          padding="14px"
          color="grey-4"
          unelevated
          @click="rating = true"
        />
      </div>
    </q-drawer>

    <q-page-container>
      <router-view
        :rating="rating"
        :submit="submit"
        @topic="setTopic"
        @rating="setRating"
        @rated="rating = false"
        @submit="(val) => submit = val"
        @reload="asyncReload('avaliableWriting')"
      />
    </q-page-container>
  </q-layout>
</template>

<script>
import MenuItem from '../components/drawer/menu-item'
import MenuProfile from '../components/header/menu-profile'
import CardTopic from '../components/composing/card-topic'
import { FetchUserMixin } from '../mixin/fetch-user'
import { formatToDate } from 'brazilian-values'

export default {
  name: 'Main',
  components: {
    MenuItem,
    MenuProfile,
    CardTopic
  },
  mixins: [FetchUserMixin],
  asyncData: {
    async avaliableWriting () {
      const query = await JSON.parse(window.sessionStorage.getItem('autoLogin'))

      await this.fetchUser(query, false)

      const { avaliableWriting } = this.$store.state.session.user

      if (!avaliableWriting) {
        return undefined
      }

      const { quantityCompositionAvaliable, dateLimit } = avaliableWriting

      return {
        quantityAvaliable: quantityCompositionAvaliable,
        dateLimit: formatToDate(new Date(dateLimit))
      }
    }
  },
  data () {
    return {
      drawer: false,
      mini: true,
      items: [
        {
          icon: 'fas fa-pencil-alt',
          label: 'Minhas redações',
          to: '/compositions'
        },
        {
          icon: 'fas fa-film',
          label: 'Vídeos',
          to: '/videos'
        }
      ],
      topic: null,
      submit: false,
      rating: false,
      hasRating: false
    }
  },
  computed: {
    isComposing () {
      return this.$route.path.includes('composing')
    }
  },
  methods: {
    async setTopic (topicId) {
      if (!topicId) {
        this.topic = null

        return undefined
      }

      try {
        const axiosConfig = {
          method: 'GET',
          url: `/Topics/${topicId}`
        }

        this.topic = await this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)
      }
    },
    setRating ({ status, rating }) {
      this.hasRating = Boolean(status === 'Corrigido' && rating && Object.keys(rating).length)
    }
  }
}
</script>
